<template>
    <div>
        <v-text-field hide-details :label="label" :value="value" 
                      @blur='emitInput' 
                      @keydown.enter='emitInput' 
                      @focus="onFocus"
                      @input="onChange"> 
        </v-text-field>
        <div class="dropdown-content" v-show="dropDownVisible">
            <div v-for="(item, index) in items" :key="index" class='dropdown-item' @click="itemClicked(item, index)">
                <span style="min-width: 8px; display: inline-block;">
                    z
                </span>
                {{ item }}
            </div>
        </div>        
    </div>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
    props: {
        label: {
            type: String,  
            required: true
        },
        value: {
            type: String,  
            required: true
        },
    },

    data() {
        return {
            dropDownVisible: false,
            items: ['ddsds', 'sdfdfdf', "jjkjk"]
        }
    },

    computed: {
        val: {
            get: function(): string { return this.value; },
            set: function(): void   { /* ignore */       }
        }
    },    

    methods: {
        emitInput(ev: any): void {
            console.log("lost focus");
            this.dropDownVisible = false;
            this.$emit("input", ev.target.value);
        },

        onFocus(ev: any): void {
            this.dropDownVisible = true;
            console.log("got focus");
        },

        onChange(ev: any): void {
            console.log("changed");
        },

        itemClicked(item: any, index: number): void {
            console.log(`item ${index} clicked`);
        }

    }    
});
</script>

<style scoped>
.dropdown-content {
  position: absolute;
  width: 85%;
  background-color: #333333;
  box-shadow: 0px 8px 32px rgba(0, 0, 0, 0.6);
  border-radius: 5px;
  overflow: auto;
  z-index: 100000000000;
}
.dropdown-item {
  color: var(--cool-gray10);
  padding: 8px 8px;
  display: block;
}
.dropdown-item:hover {
  color: white;
  background-color: darkgray;
}
</style>
